import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;
import swarm.collections.ListImpl;
import swarm.random.NormalDist;
import swarm.random.NormalDistImpl;
import swarm.random.UniformIntegerDist;
import swarm.random.UniformIntegerDistImpl;

public class Manufacturer extends SwarmObjectImpl {

  public int manufacturerId;
  public Trust[] myTrustHistory;
  public ScnModelSwarm modelSwarm;
  public ListImpl supplierList;
  public boolean trustFlag;
  public int sNum;

  public UniformIntegerDist uniPriceDist;
  public UniformIntegerDist uniTimeDist;

  public NormalDist normalAbilityDist;
  public NormalDist normalBenevolenceDist;
  public NormalDist normalIntegrityDist;

  public int maxTime;// 10days
  public int minTime;// 7days
  public int maxPrice;
  public int minPrice;

  public int[] supplierQuotePrice;
  public int[] supplierQuoteTime;
  public double[] supplierTrust;
  public double[] supplierFact;
  public double[] supplierChoice;
  public int max_index;

  public Manufacturer(Zone aZone, ScnModelSwarm s, int mId, ListImpl sList, Object generator) {
      super(aZone);
      modelSwarm = s;
      manufacturerId = mId;
      sNum = modelSwarm.numberOfSuppliers;
      maxPrice = modelSwarm.max_price;
      minPrice = modelSwarm.min_price;
      maxTime = modelSwarm.max_dtime;
      minTime = modelSwarm.min_dtime;

      supplierQuotePrice = new int[modelSwarm.numberOfSuppliers];
      supplierQuoteTime = new int[modelSwarm.numberOfSuppliers];
      supplierTrust = new double[modelSwarm.numberOfSuppliers];
      supplierFact = new double[modelSwarm.numberOfSuppliers];
      supplierChoice = new double[modelSwarm.numberOfSuppliers];

      myTrustHistory = new Trust[sNum];
      for (int i = 0; i < sNum; i++){
          myTrustHistory[i] = new Trust(modelSwarm.interestRate);
      }// end of for

      supplierList = sList;

      uniPriceDist = new UniformIntegerDistImpl(modelSwarm.getZone(), generator);
      uniTimeDist = new UniformIntegerDistImpl(modelSwarm.getZone(), generator);
      normalAbilityDist = new NormalDistImpl(modelSwarm.getZone(), generator);
      normalBenevolenceDist = new NormalDistImpl(modelSwarm.getZone(), generator);
      normalIntegrityDist = new NormalDistImpl(modelSwarm.getZone(), generator);
  }// end of constructor

  // method to get the supplier begin;
  public void choice(int quantity){
      max_index = 0;
      for (int i = 0; i < sNum; i++){
          /*
          System.out.println("In Manufacturer ,sNum =" + sNum );
          System.out.println("In Manufacturer ,(Supplier)supplierList.atOffset(0).queryPrice(quantity) =" + ((Supplier)supplierList.atOffset(0)).queryPrice(quantity) );
          System.out.println("In Manufacturer ,(Supplier)supplierList.atOffset(0).queryTime(quantity) =" + ((Supplier)supplierList.atOffset(0)).queryTime(quantity) );
          System.out.println("In Manufacturer , myTrustHistory[0].getAbility() =" + myTrustHistory[0].getAbility() );
          System.out.println("In Manufacturer , myTrustHistory[i].getBenevolence() =" + myTrustHistory[0].getBenevolence() );
          System.out.println("In Manufacturer , myTrustHistory[i].getIntegrity() =" + myTrustHistory[0].getIntegrity() );
          System.out.println("In Manufacturer ,supplierTrust[0] ="+(myTrustHistory[0].getAbility() + myTrustHistory[0].getBenevolence() + myTrustHistory[0].getIntegrity())/3);
          */
          try{
            supplierQuotePrice[i] = ((Supplier)supplierList.atOffset(i)).queryPrice(quantity);
          } catch (Exception e)
          {
	   System.err.println("Exception!! In Manufacturer ,supplierQuotePrice[i] =" + e.getMessage ());
	   System.exit(1);
	   }
          System.out.println("In Supplier ,supplierQuotePrice["+i+"] =" + supplierQuotePrice[i]);

          try{
            supplierQuoteTime[i] = ((Supplier)supplierList.atOffset(i)).queryTime(quantity);
          } catch (Exception e)
          {
	   System.err.println("Exception!! In Manufacturer ,supplierQuoteTime[i] =" + e.getMessage ());
	   System.exit(1);
	   }

          try{
            supplierTrust[i] = (myTrustHistory[i].getAbility() + myTrustHistory[i].getBenevolence() + myTrustHistory[i].getIntegrity())/3;
          } catch (Exception e)
          {
	   System.err.println("Exception!! In Manufacturer ,supplierTrust[i] =" + e.getMessage ());
	   System.exit(1);
	   }

          int transactionTime = myTrustHistory[i].getTransactionTime();
          double propensity = transactionTime/ modelSwarm.orderList[i].getCount();

          if (propensity <= 0.2)
          {
            try{
            supplierFact[i] = Globals.env.uniformDblRand.getDoubleWithMin$withMax(0,0.2);
            } catch (Exception e)
            {
  	    System.err.println("Exception!! In Manufacturer ,supplierFact[i] error =" + e.getMessage ());
	    System.exit(1);
	    }
            System.out.println("In Manufacturer ,propensity <= 0.2, supplierFact["+i+"] =" + supplierFact[i] );
          }
          else if (propensity <= 0.4 && propensity > 0.2)
          {
            try{
            supplierFact[i] = Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.2,0.4);
            } catch (Exception e)
            {
  	    System.err.println("Exception!! In Manufacturer ,propensity <= 0.4 && propensity > 0.2, supplierFact[i] error =" + e.getMessage ());
	    System.exit(1);
	    }
            System.out.println("In Manufacturer ,supplierFact["+i+"] =" + supplierFact[i] );
           }
          else if (propensity > 0.4 && propensity <= 0.6)
            supplierFact[i] = Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.4,0.6);
          else if (propensity > 0.6 && propensity <= 0.8)
            supplierFact[i] = Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.6,0.8);
          else
            supplierFact[i] = Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.8, 1.0);

          supplierChoice[i] = supplierFact[i] * supplierTrust[i] + (1 - supplierFact[i]) * (supplierQuotePrice[i] + supplierQuoteTime[i])/2;          supplierChoice[i] = supplierFact[i] * supplierTrust[i] + (1 - supplierFact[i]) * (supplierQuotePrice[i] + supplierQuoteTime[i])/2;          supplierChoice[i] = supplierFact[i] * supplierTrust[i] + (1 - supplierFact[i]) * (supplierQuotePrice[i] + supplierQuoteTime[i])/2;
      }

      for (int i = 0; i < sNum; i++){
        if (supplierChoice[i] > supplierChoice[max_index])
            max_index = i;
      }
  }

  public void choiceM(int quantity){
      max_index = 0;
      for (int i = 0; i < sNum; i++){
          supplierQuotePrice[i] = ((Supplier)supplierList.atOffset(i)).queryPrice(quantity);
          supplierQuoteTime[i] = ((Supplier)supplierList.atOffset(i)).queryTime(quantity);
          supplierChoice[i] = (supplierQuotePrice[i] + supplierQuoteTime[i])/2;
      }
      for (int i = 0; i < sNum; i++){
        if (supplierChoice[i] > supplierChoice[max_index])
            max_index = i;
      }
  }

  public int getMax_index(){
      return max_index;
  }

  public int getMax_Price(){
      return supplierQuotePrice[this.getMax_index()];
  }

  public int getMax_Time(){
      return supplierQuoteTime[this.getMax_index()];
  }

  // method to get the best supplier end;

  // method to generate the price for customer's query

  public int queryPrice(int quantity){
      this.choice(quantity);
      return this.getMax_Price() + uniPriceDist.getIntegerWithMin$withMax(modelSwarm.min_price, modelSwarm.max_price);
  }

  public int queryTime(int quantity){
      return this.getMax_Price() + uniTimeDist.getIntegerWithMin$withMax(modelSwarm.min_dtime, modelSwarm.max_dtime);
  }

  public int getDeliveryTime(int sId){
      int deliveryTime;
      double deliverTimeMean = myTrustHistory[sId].getIMean();
      double deliverTimeVar = myTrustHistory[sId].getIVar();
      deliveryTime = (int)normalAbilityDist.getSampleWithMean$withVariance(deliverTimeMean, deliverTimeVar);
      if (deliveryTime <= 1)
          return 1;
      else return deliveryTime;
  }

  public int getCheckTime(int sId){
      int checkTime;
      double checkTimeMean = myTrustHistory[sId].getAMean();
      double checkTimeVar = myTrustHistory[sId].getAVar();
      checkTime = (int)normalAbilityDist.getSampleWithMean$withVariance(checkTimeMean, checkTimeVar);
      if (checkTime <=1)
          return 1;
      else return checkTime;
  }

  public int getBargainTime(int sId){
      int bargainTime;
      double bargainTimeMean = myTrustHistory[sId].getBMean();
      double bargainTimeVar = myTrustHistory[sId].getBVar();
      bargainTime = (int)normalBenevolenceDist.getSampleWithMean$withVariance(bargainTimeMean, bargainTimeVar);
      if (bargainTime <= 1)
          return 1;
      else return bargainTime;
  }
}