import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;
import swarm.random.UniformIntegerDist;
import swarm.random.UniformIntegerDistImpl;

public class Supplier extends SwarmObjectImpl {
  public int supplierId;
  public ScnModelSwarm modelSwarm;
  public Material myMaterial;

  public Supplier(Zone aZone, ScnModelSwarm s, Object generator, int sId) {
      super(aZone);
      supplierId = sId;
      modelSwarm = s;
      myMaterial = new Material(s, generator);
  }

  public int queryPrice(int quantity){
      return myMaterial.getPrice(quantity);
  }

  public int queryTime(int quantity){
      return myMaterial.getDT(quantity);
  }
  //inner class begin:
  public class Material{
    public int price = 0;
    public int deliverTime = 0;
    public int maxPrice;
    public int minPrice;
    public int maxTime;
    public int minTime;
    public ScnModelSwarm modelSwarm;

    public UniformIntegerDist uniPriceDist;
    public UniformIntegerDist uniDTDist;

    public Material(ScnModelSwarm s, Object generator){
        modelSwarm = s;
        uniPriceDist = new UniformIntegerDistImpl(modelSwarm.getZone(), generator);
        uniDTDist = new UniformIntegerDistImpl(modelSwarm.getZone(), generator);
        maxPrice = modelSwarm.m_max_price;
        minPrice = modelSwarm.m_min_price;
        maxTime = modelSwarm.m_max_dtime;
        minTime = modelSwarm.m_min_dtime;
    }

    public int getPrice(int quantity){
      return quantity * uniPriceDist.getIntegerWithMin$withMax(maxPrice,minPrice);
    }

    public int getDT(int quantity){
      return quantity * uniDTDist.getIntegerWithMin$withMax(maxTime, minTime);
    }
  }
  //inner class end:
}