import swarm.Globals;
import swarm.defobj.Zone;
import swarm.collections.List;
import swarm.collections.ListImpl;

public class Trust {

  public List abilityList;
  public List benevolenceList;
  public List integrityList;
  public List timeList;//triggerTime;
  public double interestRate;

  public Trust(double iRate) {
      abilityList = new ListImpl(Globals.env.globalZone);
      benevolenceList = new ListImpl(Globals.env.globalZone);
      integrityList = new ListImpl(Globals.env.globalZone);
      timeList = new ListImpl(Globals.env.globalZone);
      interestRate = iRate;
  }

  public int getTransactionTime(){
      return abilityList.getCount();
  }

  public void addAbility(int ability){
      abilityList.addLast(new Integer(ability));
  }
  public void addBenevolence(int benevolence){
      benevolenceList.addLast(new Integer(benevolence));
  }
  public void addIntegrity(int integrity){
      integrityList.addLast(new Integer(integrity));
  }
  public void addtimeList(int currentTime){
      timeList.addLast(new Integer(currentTime));
  }

  public double getAbility(){
      double ability = 0;
      if (abilityList.getCount() == 0){
          return ability = 0.5;
      } //end of if
      else{
          for (int i = 0; i < abilityList.getCount(); i++){
              ability += (((Integer)abilityList.atOffset(i)).intValue()) * (Math.pow(interestRate, (((Integer)timeList.getLast()).doubleValue() - ((Integer)timeList.atOffset(i)).doubleValue())));
          }// end of for
          return ability;
      } //end of else
  }// end of getAbility()

  public double getBenevolence(){
      double benevolence = 0;
      if (benevolenceList.getCount() ==0){
          return benevolence = 0.5;
      }// end of if
      else{
          for (int i = 0; i < benevolenceList.getCount(); i++){
              benevolence += (((Integer)benevolenceList.atOffset(i)).intValue()) * (Math.pow(interestRate, (((Integer)timeList.getLast()).doubleValue() - ((Integer)timeList.atOffset(i)).doubleValue())));
          }// end of for
          return benevolence;
      }// end of else
  }// end of getBenevolence()

  public double getIntegrity(){
      double integrity = 0;
      if (integrityList.getCount() == 0){
          return integrity = 0.5;
      }//end of if
      else{
          for (int i = 0; i < integrityList.getCount(); i++){
              integrity += (((Integer)integrityList.atOffset(i)).intValue()) * (Math.pow(interestRate,(((Integer)timeList.getLast()).doubleValue() - ((Integer)timeList.atOffset(i)).doubleValue())));
          }// end of for
          return integrity;
      }// end of else
  }

  public double getAMean(){
      double sum = 0;
      for (int i = 0; i < abilityList.getCount(); i++){
          sum += ((Integer)abilityList.atOffset(i)).doubleValue();
      }
      return sum/abilityList.getCount();
  }

  public double getAVar(){
      double average = this.getAMean();
      double sumsquare = 0;
      for (int i = 0; i < abilityList.getCount(); i++){
          sumsquare += Math.pow(((Integer)abilityList.atOffset(i)).doubleValue() - average, 2);
      }
      return sumsquare/abilityList.getCount();
  }

  public double getBMean(){
      double sum = 0;
      for (int i = 0; i < benevolenceList.getCount(); i++){
          sum += ((Integer)benevolenceList.atOffset(i)).doubleValue();
      }
      return sum/benevolenceList.getCount();
  }

  public double getBVar(){
      double average = this.getBMean();
      double sumsquare = 0;
      for (int i = 0; i < benevolenceList.getCount(); i++){
          sumsquare += Math.pow(((Integer)benevolenceList.atOffset(i)).doubleValue() - average, 2);
      }
      return sumsquare/benevolenceList.getCount();
  }

  public double getIMean(){
      double sum = 0;
      for (int i = 0; i < integrityList.getCount(); i++){
          sum += ((Integer)integrityList.atOffset(i)).doubleValue();
      }
      return sum/integrityList.getCount();
  }

  public double getIVar(){
      double average = this.getIVar();
      double sumsquare = 0;
      for (int i = 0; i < integrityList.getCount(); i++){
          sumsquare += Math.pow(((Integer)integrityList.atOffset(i)).doubleValue() - average, 2);
      }
      return sumsquare/integrityList.getCount();
  }
}